part of tecfy_core_client_package;

class EntityListTileComponent extends StatelessWidget {
  final Entity entity;
  final dynamic data;
  Property titleField;
  Property subTitleField;
  Property tailField;
  final void Function(dynamic) onClick;

  EntityListTileComponent(this.entity, this.data, {this.onClick}) {
    // TODO: move these properties to [Entity] class to save calling them everytime need to print list item
    var props =
        entity.gridProperties; //.where((e) => e.dbName != 'active').toList();
    var dis = entity.gridProperties.where((e) => e.isDisplayField).toList();
    if (dis.length > 0) {
      titleField = dis[0];
      props = props.where((e)=> e.dbName != titleField.dbName).toList();
      subTitleField = props.length > 0 ? props[0] : null;
      tailField = props.length > 1 ? props[1] : null;
      if (tailField == null && subTitleField != null) {
        tailField = subTitleField;
        subTitleField = null;
      }
    } else {
      titleField = props.length > 0 ? props[0] : null;
      subTitleField = props.length > 1 ? props[1] : null;
      tailField = props.length > 2 ? props[2] : null;
      if (tailField == null && subTitleField != null) {
        tailField = subTitleField;
        subTitleField = null;
      }
    }
  }

  @override
  Widget build(BuildContext context) {
    return ListTile(
      leading: entity.hasPhoto
          ? PhotoViewProperty(data: data[entity.photoPropName].toString())
          : null,
      title: titleField == null
          ? null
          : titleField.getDisplayWidget(data,
              size: 16,
              color: Colors
                  .black), //, style:TextStyle(color: data['active'] == false ? Colors.red : Colors.black)),
      subtitle: subTitleField == null
          ? null
          : subTitleField.getDisplayWidget(data,
              size: 14, color: Colors.black54),
      trailing: tailField == null
          ? null
          : tailField.getDisplayWidget(data, size: 10, color: Colors.black87),
      onTap: () => onClick == null ? print('') : onClick(data),
    );
  }
}
