part of tecfy_core_client_package;

class ReportDetailPage extends StatefulWidget {
  final dynamic report;
  final List<EntityFilter> filter;
  ReportDetailPage(this.report,this.filter);
  @override
  _ReportDetailPageState createState() => _ReportDetailPageState();
}

class _ReportDetailPageState extends State<ReportDetailPage> {

  List<dynamic> data;
  dynamic totals;

  @override
  void initState() {
    getData();
    super.initState();
  }

  getData()async{
    var result = await ApiService.httpGetDynamic('Report/GetData/${widget.report['dbName']}'+ ((widget.filter?.length ?? 0) > 0
            ? '?filter=${jsonEncode(widget.filter.map<Map>((f) => f.toJson()).toList())}'
            : ''));
    print(result.data);
    if(result.success){
       data = result.data; 
       totals = data.removeLast();
      setState(() {
      });
    }else{
      await AppNavigator.showMessage(context, result.message ?? "Error!");
      Navigator.pop(context);
    }
  }

  @override
  Widget build(BuildContext context) {
    return BasePage(context, widget.report['name${LocalConfigService.languagePrefex}'],
      child:data == null ? Center(child: CircularProgressIndicator(valueColor:AlwaysStoppedAnimation<Color>(ThemeService.mainColor))) : 
      SingleChildScrollView(
        child: Table(
        children: data.map<TableRow>((d)=>
          TableRow(
            children: widget.report['properties'].map<TableCell>((p)=> getCell(p, d)).toList(),
          )
        ).toList()
        ..add(TableRow(
            children: widget.report['properties'].map<TableCell>((p)=> getCell(p, totals,totals:true)).toList(),
          ))
        ..insert(0, TableRow(
          children: widget.report['properties'].map<TableCell>((p)=>TableCell(child: Text(p['name${LocalConfigService.languagePrefex}'] ?? 'N/A', style: ThemeService.titleStyle))).toList(),
        ))
      ),
    ));
  }
  
  
  TableCell getCell(prop,data,{totals:false}){
    var val = data[prop['dbName']];
    
    if(totals){
      if(val == null || val == 0 || val == '' || val == '0') return TableCell(child:Container());
    }
    else{
        if(val == null) return TableCell(child:Container());
    }
    switch(ValueTypes.values[prop['type'] as int]){
      case ValueTypes.Text:
      return TableCell(child:Text(val, style: totals? ThemeService.titleStyle : TextStyle(fontSize: 12)));
      case ValueTypes.Number:
      return TableCell(child:Text((val as num).toDouble().toStringAsFixed(2),style: totals? ThemeService.titleStyle :TextStyle(fontSize: 12)));
      case ValueTypes.DateTime:
      return TableCell(child:Text( val.toString().replaceFirst('T', ' ').substring(0,16),style: totals? ThemeService.titleStyle :TextStyle(fontSize: 10)));
      default:
      return TableCell(child:Text('-'));
    }
  }

  lowerFirst(String s){
    return '${s[0].toLowerCase()}${s.substring(1)}';
  }
}